import streamlit as st
import networkx as nx
import src.basic as tmp

tmp.base('GEXFToTermOcc')


def create_file(file):
    tmp = file.getvalue().decode('utf-8') \
        .replace('version="1.3"', 'version="1.2"') \
        .replace('xmlns="http://www.gexf.net/1.3"', 'xmlns="http://www.gexf.net/1.2draft"') \
        .replace('xmlns:viz="http://gexf.net/1.3/viz"', 'xmlns:viz="http://www.gexf.net/1.2draft/viz"') \
        .replace('xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"', 'xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"') \
        .replace('xsi:schemaLocation="http://gexf.net/1.3 http://gexf.net/1.3/gexf.xsd"', 'xsi:schemaLocation="http://www.gexf.net/1.2draft http://www.gexf.net/1.2draft/gexf.xsd"') \
        .encode()
    file.seek(0,0)
    file.write(tmp)
    file.seek(0,0)
    
    tmp = nx.read_gexf(file, version='1.2draft')

    lst=[]
    for elem in tmp.nodes(True):
        lst.append((elem[1]['label'],elem[1]['viz']['size']))

    lst.sort(key= lambda x: x[1], reverse=True)

    res = 'mapTerm\tocc\n'
    for elem in lst:
        res += elem[0] + '\t' + str(int(elem[1])) + '\n'
    return res

st.write(st.session_state.general_text_dict['text'])
file = st.file_uploader(st.session_state.general_text_dict['file'],type=["gexf"],key='file')

if file:
    try:
        st.write(st.session_state.general_text_dict['new_file'])
        st.download_button('Download TSV', create_file(file), 'output.csv')
    except Exception as e:
        st.write(st.session_state.general_text_dict['error'])
    
    