"""
Streamlit Application
Marie FU
"""

import json
import os
import tempfile
import src.basic as tmp
import streamlit as st
from src.gerneralFileOP import *
from zipfile import ZipFile
import shutil

STATE = st.session_state


def getData(jsontxt):
    
    jsontxt = jsontxt["results"]["hits"]

    for i in range(len(jsontxt)):

        res = ""

        content = jsontxt[i]["_source"]

        abstract = content['tx']

        date = '\t'.join(content['ca'][:10].split('-'))

        try:
            source = content["entities"]["urls"][0]["expanded_url"]
        except (IndexError, KeyError):
            source = "1"

        authors = f"{content['usr']['unm']} {content['usr']['snm']}"

        title = "1"

        res = f"{date}\t{title}\t{authors}\t{source}\t{abstract}".replace("\n"," ").replace("\"","”")

        STATE.fileData += f"{res}\n"


tmp.base("MultivactoTSV")

st.write(st.session_state.general_text_dict["description"])

STATE.newFileName = st.text_input(label=STATE.general_text_dict["file_name_input"],placeholder="File.tsv")

st.file_uploader(st.session_state.general_text_dict['file'], type = ['json','zip'], key="file")

if STATE.file is not None:
    # first utilisation of errMessageLog, contain the log of every error message encountered
    STATE.errMessageLog = ""
    STATE.newFileName = checkNewFileName(STATE.newFileName, STATE.file.name)

    if not STATE.newFileName:
        STATE.errMessageLog += st.session_state.general_text_dict['err_file_name']
        errDisplay(STATE.errMessageLog)
    else :
        if STATE.file.type == "application/json":
            
            STATE.fileData = "Publication Year\tPublication Month\tPublication Day\tTitle\tAuthors\tSource\tAbstract\n"
            jsontxt = json.loads(STATE.file.getvalue().decode())
            
            try:
                getData(jsontxt)

                show_download_button(STATE.newFileName, STATE.fileData)
            except KeyError:
                STATE.errMessageLog += st.session_state.general_text_dict['bad_file']
                errDisplay(STATE.errMessageLog)
        else:
            STATE.allFileData = ""

            # temporary directory for input files
            STATE.filesDir = tempfile.TemporaryDirectory()

            # remporary directory for output files
            STATE.zipDir = tempfile.TemporaryDirectory()
            os.mkdir(os.path.join(STATE.zipDir.name, "MultivacToTSV"))

            with ZipFile(STATE.file, 'r') as zip:
                for info in zip.infolist():
                    if info.filename[-5:] == ".json":
                        zip.extract(info, STATE.filesDir.name)
                
            for file in os.listdir(STATE.filesDir.name):
                STATE.fileData = "Publication Year\tPublication Month\tPublication Day\tTitle\tAuthors\tSource\tAbstract\n"
                jsontxt = ""
                with open(STATE.filesDir.name + "/" + file, "r") as f:
                    jsontxt = json.loads(f.read())

                getData(jsontxt)

                with open(STATE.zipDir.name + "/MultivacToTSV/" + file[:-5] + ".tsv", "w") as f:
                    f.write(STATE.fileData.replace("\"","”"))

                if STATE.allFileData == "":
                    STATE.allFileData = STATE.fileData
                else:
                    STATE.allFileData += STATE.fileData[81:]
                
            with open(STATE.zipDir.name + "/MultivacToTSV/compiledFiles.tsv", "w") as f:
                f.write(STATE.allFileData.replace("\"","”"))
            shutil.make_archive(STATE.filesDir.name + "/MultivacToTSV", "zip", STATE.zipDir.name)

            with open(STATE.filesDir.name + "/MultivacToTSV.zip", "rb") as zip:
                x=zip.read()
            show_download_button(STATE.newFileName[:-3]+"zip", x)

    STATE.file.close()
